﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MontoyaTech.Rest.Net.Example
{
    using System;
    using System.Net.Http;

    public class Client
    {
        public string BaseUrl;

        private HttpClient HttpClient;

        public TestApi Test;

        public Client(string baseUrl)
        {
            this.BaseUrl = baseUrl;
            this.Test = new TestApi(this);
            this.HttpClient = new HttpClient();
            this.HttpClient.DefaultRequestHeaders.Add("Accept", "*/*");
            this.HttpClient.DefaultRequestHeaders.Add("Connection", "keep-alive");
            this.HttpClient.DefaultRequestHeaders.Add("Accept-Encoding", "identity");
        }

        public class TestApi
        {
            public Client Client;

            public TestApi(Client client)
            {
                this.Client = client;
            }

            public string Status()
            {
                var request = new HttpRequestMessage(HttpMethod.Get, $"{this.Client.BaseUrl}/status");
                return default;
            }

            public string Add(double a, double b)
            {
                var request = new HttpRequestMessage(HttpMethod.Post, $"{this.Client.BaseUrl}/add/{a}/{b}");
                return default;
            }

            public string Signup(User user)
            {
                var request = new HttpRequestMessage(HttpMethod.Post, $"{this.Client.BaseUrl}/signup/{user}");
                return default;
            }

            public User Json()
            {
                var request = new HttpRequestMessage(HttpMethod.Get, $"{this.Client.BaseUrl}/json");
                return default;
            }
        }

        public class User
        {
            public string Name;

            public System.Collections.Generic.List<string> List;

            public ulong Property { get; set; }
        }
    }
}
